// Base64 encoding functions
// These are used to encode the password used to access the AudioTron.

// base64 encoding conversion table
static char basis_64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

// Internal function to output a chunk of base64
void output64chunk(unsigned char c1, unsigned char c2, unsigned char c3, int pads, char *outbuf)
{
    *outbuf++ = basis_64[c1 >> 2];
    *outbuf++ = basis_64[((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)];
    if (pads == 2) {
        *outbuf++ = '=';
        *outbuf++ = '=';
    } else if (pads) {
        *outbuf++ = basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6)];
        *outbuf++ = '=';
    } else {
        *outbuf++ = basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6)];
        *outbuf++ = basis_64[c3 & 0x3F];                        
    }  
}

// Encodes the given buffer as base64, returning the # of characters in the base64 output
int to64(char *inbuf, char *outbuf, int nchars) 
{
    int ct, ct1, i, bytes_left, limit;
    unsigned char c1, c2, c3;
	limit = 68;

	ct = 0;
	ct1 = 0;

	for(i = 0; i < nchars; i += 3)
	{
		bytes_left = nchars - i;

		c1 = *inbuf++;
		if (bytes_left > 1)
			c2 = *inbuf++;
		if (bytes_left > 2)
			c3 = *inbuf++;

		if (bytes_left == 1)
		{
			output64chunk(c1, 0, 0, 2, outbuf);
			outbuf += 4;
		}
		if (bytes_left == 2)
		{
			output64chunk(c1, c2, 0, 1, outbuf);
			outbuf += 4;
		}
		if (bytes_left > 2)
		{
			output64chunk(c1, c2, c3, 0, outbuf);
			outbuf += 4;
		}
		ct += 4;
		ct1 += 4;
		if (ct1 > limit)
		{ 		  
			*outbuf++ = '\n';
			ct1 = 0;
			ct++;
		}
	}
	if (ct1 <= limit && ct1 != 0)
	{
		ct++;
		*outbuf++ = '\n';
	}
	return ct;
}
